//enable/disable icon activation status
var plugin_active = false;


function send_status_to_selected_tab(current_tab_id) {
   chrome.tabs.sendMessage(
      current_tab_id,
      {
         "type": "status_changed_data_from_background",
         "active": plugin_active,
      },
      {},
      function(response) {
         if (chrome.runtime.lastError) {
            //console.log("error:" + chrome.runtime.lastError);
         }
      }
   );
}

chrome.browserAction.onClicked.addListener(function(tab) {

   plugin_active = !plugin_active;

   //enable plugin
   if (plugin_active){
      chrome.browserAction.setIcon({path:"shn_dl_on.png"});
      request_interval = 1000;
   } else {
      chrome.browserAction.setIcon({path:"shn_dl_off.png"});
   }


   //send to each tab the signal that the state of the plugin is changed
   chrome.tabs.query({}, function(tabs) {

      for (var current_tab = 0; current_tab < tabs.length; current_tab++) {

         send_status_to_selected_tab(tabs[current_tab].id);

      }

   });

});


var buffer = {};
var buffer_session_positions = 6;
var element_max_positions = 64;

var expressions = {
   "Google Tag Manager" : ["googletagmanager.com"],
   "Google Analytics" : ["google-analytics.com", "doubleclick.net"],
   "ShinyStat" : ["shinystat.com"],
}


//on tab closure remove corrispondent data from buffer
chrome.tabs.onRemoved.addListener(function(tabid, removed) {
   if (buffer.hasOwnProperty(tabid))
      delete buffer[tabid];
})

function insert_buffer_element(tab_id, request, timestamp) {
   var buffer_tab;

   if (Object.keys(buffer).length > 64)
	return;


   //first data received from this tab_id
   if (buffer.hasOwnProperty(tab_id) === false) {
      buffer[tab_id] = {};
      buffer[tab_id].current_position = 0;
      buffer[tab_id].current_id = 0;
      buffer[tab_id].sessions = [];
      buffer[tab_id].sessions[0] = {}
      buffer[tab_id].sessions[0].url = request.url;
      buffer[tab_id].sessions[0].id = 0;
      buffer[tab_id].sessions[0].dl_details = {};
      buffer[tab_id].sessions[0].element_position = 0;
      buffer[tab_id].sessions[0].elements = []
   }


   buffer_tab = buffer[tab_id];

   //change url has been experimented
   if (buffer_tab.sessions[buffer_tab.current_position].url != request.url) {

      buffer_tab.current_id += 1;
      buffer_tab.selected_session = buffer_tab.current_id;
      buffer_tab.current_position += 1;
      buffer_tab.current_position %= buffer_session_positions;

      buffer_tab.sessions[buffer_tab.current_position] = {};
      buffer_tab.sessions[buffer_tab.current_position].id = buffer_tab.current_id;
      buffer_tab.sessions[buffer_tab.current_position].url = request.url;
      buffer_tab.sessions[buffer_tab.current_position].dl_details = {};
      buffer_tab.sessions[buffer_tab.current_position].element_position = 0;
      buffer_tab.sessions[buffer_tab.current_position].elements = [];
      buffer_tab.sessions[buffer_tab.current_position].dataLayer = {};
      buffer_tab.sessions[buffer_tab.current_position].tc_vars = {};
   }

   if (typeof request.dataLayer !== "undefined")
      buffer_tab.sessions[buffer_tab.current_position].dataLayer = request.dataLayer;

   if (typeof request.tc_vars !== "undefined"){
      buffer_tab.sessions[buffer_tab.current_position].tc_vars = request.tc_vars;
      buffer_tab.sessions[buffer_tab.current_position].dl_details["TC"] = true;
   }

   if (typeof request.element !== "undefined") {
      buffer_tab.sessions[buffer_tab.current_position].elements[buffer_tab.sessions[buffer_tab.current_position].element_position] = request.element;
      buffer_tab.sessions[buffer_tab.current_position].element_position += 1;
      buffer_tab.sessions[buffer_tab.current_position].element_position %= element_max_positions;
      buffer_tab.sessions[buffer_tab.current_position].dl_details[get_google_details(request.element)] = true;
   }

   if (typeof buffer_tab.sessions[buffer_tab.current_position].url == "undefined") {
      chrome.tabs.get(tab_id, function (tabDetails) {
         if (chrome.runtime.lastError){
            //console.log(chrome.runtime.lastError);
         }
         if (typeof tabDetails !== "undefined")
         buffer_tab.sessions[buffer_tab.current_position].url = tabDetails.url;
      });
   }

   if (active_tab_id == tab_id)
      send_data_to_tab(tab_id);
}


function get_google_details(el) {
   if ((el.name == "Google Analytics") && (el.url.indexOf("collect")>-1)) {
      if (el.url.indexOf("&t=pageview&")>-1)
         return "PV";
      else if (el.url.indexOf("&t=event&")>-1)
         return "EV";
   }
   else if ((el.name == "Google Analytics") && (el.url.indexOf("__utm.gif")>-1)) {
      if (el.url.indexOf("&utmt=")==-1)
        return "PV";
      else if (el.url.indexOf("&utmt=event&")>-1)
        return "EV";
   }

   return "";
}

//get the data related to the selected_session
function get_sessions_data(buffer_tab){
   var session_data = {};
   session_data.history = {};
   session_data.history.url_list = [];
   session_data.history.id_list = [];
   session_data.history.dl_details_list = [];

   if (typeof buffer_tab === "undefined")
      return session_data;

   var current_position = buffer_tab.current_position;
   var sessions_len = buffer_tab.sessions.length;

   //get the position of the required session
   var position;
   if (typeof buffer_tab.selected_session !== "undefined"){
      position = buffer_tab.selected_session % buffer_session_positions;
      //if the selected session id has been already overwritten by a different session id, take the last one
      if (typeof buffer_tab.sessions[position].id !== "undefined" && buffer_tab.sessions[position].id != buffer_tab.selected_session)
         position = buffer_tab.current_position;
   }else{
      position = buffer_tab.current_position;
   }
   session_data.session_id = buffer_tab.sessions[position].id;


   var i;
   for (i=0; i<sessions_len; i++){
      session_data.history.url_list.push(buffer_tab.sessions[current_position].url);
      session_data.history.id_list.push(buffer_tab.sessions[current_position].id);
      session_data.history.dl_details_list.push(buffer_tab.sessions[current_position].dl_details);
      current_position += buffer_session_positions - 1;
      current_position %= buffer_session_positions;
   }

   session_data.url = buffer_tab.sessions[position].url;
   session_data.dataLayer = buffer_tab.sessions[position].dataLayer;
   session_data.tc_vars = buffer_tab.sessions[position].tc_vars,
   session_data.elements = buffer_tab.sessions[position].elements;

   return session_data;
}


//listen to communication from tab content
chrome.runtime.onMessage.addListener(

   function(request, sender, sendResponse) {

      if ( (typeof request.type !== "undefined") && (request.type === "from_content_data") ) {
         insert_buffer_element(sender.tab.id, request);
      }

      if ( (typeof request.type !== "undefined") && (request.type === "content_has_been_load") ) {
         request_interval = 1000;
         send_status_to_selected_tab(sender.tab.id);
      }
      
      if ( (typeof request.type !== "undefined") && (request.type === "label_has_been_clicked") ) {
         request_interval = 1000;
      }

      if ( (typeof request.type !== "undefined") && (request.type === "history_url_has_been_clicked") ) {
         send_data_to_tab(sender.tab.id, request.session_id);
      }

   }
);


function send_data_to_tab(tab_id, session_id){

   var buffer_tab = buffer[tab_id];
    
            
   if (typeof buffer_tab !== "undefined") {
  
      //keep memory that a specific session has been selected by the user inside the current tab 
      if (typeof session_id !== "undefined") 
         buffer_tab.selected_session = session_id;
      
      chrome.tabs.sendMessage(
         tab_id, 
         {
            "type": "data_from_background_to_content",
            "sessions_data": get_sessions_data(buffer_tab, session_id)
         },
         {},
         function(response) {
            if (chrome.runtime.lastError) {
               //console.log("error:" + chrome.runtime.lastError);
            }
         }
      );

   }

}


var i = 0;
var active_tab_id;
var request_for_update_times = 100;
var request_interval = 1000;

function main_loop () {

   setTimeout(function () {

      if (plugin_active) {

         if ((1000 % request_interval) == 0) {


            //send data to active tab
            chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
        
               active_tab_id = undefined;
               //no active tab
               if (typeof tabs[0] === "undefined")
                  return;
         
               active_tab_id = tabs[0].id;

            });


            //request data update
            chrome.tabs.query({}, function(tabs) {
         
               for (var current_tab = 0; current_tab < tabs.length; current_tab++) {
         
                  //send the request always when the tab is active, otherwise with a low frequency
                  if ((typeof active_tab_id !== "undefined" && active_tab_id == tabs[current_tab].id) || (i % request_for_update_times == 0)){
                
                      chrome.tabs.sendMessage(
                         tabs[current_tab].id,
                         {
                            "type": "request_data_from_background"
                         },
                         {},
                         function(response) {
                            if (chrome.runtime.lastError) {
                               //console.log("error:" + chrome.runtime.lastError);
                            }
                         }
 
                      );

                   }
                }

            });

         }
      
         if (request_interval < 6000)
            request_interval += 1000;

      }
         
      i++;
      main_loop();
      

   }, 1000)
}

main_loop();






/**
 * If the request url matches one inside expressions list the function sets the name
 * .
 * When the extension button is still not clicked, keep the data inside a buffer 
 * for a maximum of buffer_limit elements.
 */ 
function url_analysis(req){
   var call = {};
   var name;

   if (plugin_active) {

      //search expression inside request url
      if (req.url.indexOf("addons.shinystat.com")==-1){
         for (var name_exp in expressions) {
            for (var i=0; i<expressions[name_exp].length; i++) {
               //if ((req.type == "script" || req.type == "image") && (req.url.indexOf(expressions[name_exp])>-1)){
               if (req.url.indexOf(expressions[name_exp][i])>-1){
                  name = name_exp;
                  break;
               }
            }
         }
      }

      if (typeof name == "undefined")
         return;


      chrome.tabs.get(req.tabId, function (tabDetails){
         if (chrome.runtime.lastError){
            //console.log(chrome.runtime.lastError);
         }
 
         call["element"] = {};
         call["element"]["name"] = name;
         call["element"]["url"] = req.url;
         call["element"]["timestamp"] = req.timeStamp;
         if (typeof tabDetails !== "undefined")
            call["url"] = tabDetails.url;
         else
            call["url"] = undefined;

         insert_buffer_element(req.tabId, call);

      });

   }
   
};


//each new web request call function url_analysis
chrome.webRequest.onBeforeRequest.addListener(url_analysis, {urls:["<all_urls>"]});




