function dl_get_label_list(sel) {
   var i = 0;

   var label_list = [
      {
         id:    "dl_sm_link",
         color: "#4CAF50",
         label: "Summary"
      },
      {
         id:    "dl_gtm_link",
         color: "#FF8000",
         label: "Google Tag Manager<br>Data Layer"
      },
      {
         id:    "dl_ga_link",
         color: "#F44336",
         label: "Google Analytics<br>Data Layer"
      },
      {
         id:    "dl_tc_link",
         color: "#2196F3",
         label: "Tag Commander<br>Data Layer"
      }
   ];

   if (typeof sel === "undefined")
      return label_list;

   for (i=0; i<label_list.length; i++) {
      if ( label_list[i].id.indexOf("_" + sel + "_") > -1)
         return [label_list[i]];
   }

   return [];
}



function dl_tablink_clicked(link_id) {
   var iframe = document.getElementById("dl_iframe"); 
   var tablinks = document.getElementsByClassName("dl_tablink");
   
   for (var i = 0; i < tablinks.length; i++) {
      tablinks[i].className = tablinks[i].className.replace(" active", "");

      if (tablinks[i].id == link_id) {
         tablinks[i].className += " active";

         try {
            iframe.contentWindow.postMessage({
               "type": "display_tc_vars",
               "change": link_id,
            }, "https://webapi.shiny.it");
         } catch (err) {}
      }
   }

}


function dl_load_elements() {

   var iframe = document.getElementById("dl_iframe"); 
   if (!!iframe && typeof iframe !== "undefined") {
      return;
   }

   var label_list = dl_get_label_list();

   var iframe = document.createElement("iframe"); 
   var manifest_version = chrome.runtime.getManifest().version;
   iframe.id = "dl_iframe";
   iframe.src = "https://webapi.shiny.it/addons/dl_vars_check/?v=" + manifest_version;

   var history = document.createElement("div"); 
   history.id = "dl_history";

   var history_text = document.createElement("div"); 
   history_text.id = "dl_history_text";
   history.appendChild(history_text);

   for (var i = 0; i < label_list.length; i++) {
      var link = document.createElement("div");
      var span = document.createElement("span");

      //set active only the first tablink
      link.className = "dl_tablink";
      link.id = label_list[i].id;
      link.style.background = label_list[i].color;
      link.style.top = (20 + i*64) + "px";

      if (typeof label_list[i].label !== "undefined")
         span.innerHTML = label_list[i].label;
      if (label_list[i].label.indexOf("<br>") == -1)
         span.style.padding = "14px";

      link.addEventListener("click", function(){
         dl_tablink_clicked(this.id);
            
         content.style.setProperty("display", "flex", "important");
         button.style.setProperty("display", "flex", "important");
         history.style.setProperty("display", "flex", "important");
         iframe.style.setProperty("display", "flex", "important");

         chrome.runtime.sendMessage({
            "type": "label_has_been_clicked"
         });

      });

      link.appendChild(span);
      document.body.appendChild(link);
   }


   var button = document.createElement("button");
   button.id = "dl_button_x";
   button.innerHTML = "x";
   button.addEventListener("click", function(){  
      content.style.setProperty("display", "none", "important");
      button.style.setProperty("display", "none", "important");
      history.style.setProperty("display", "none", "important");
      iframe.style.setProperty("display", "none", "important");
      
      dl_tablink_clicked("");
   }, false);

   var content_overlay = document.createElement("div");
   content_overlay.id = "dl_tabcontent_overlay";

   var content = document.createElement("div");
   content.id = "dl_tabcontent";

   var super_content = document.createElement("div");
   super_content.id = "dl_super_tabcontent";

   super_content.appendChild(button);
   super_content.appendChild(content);
   content.appendChild(history);
   content.appendChild(iframe);

   document.body.appendChild(super_content);
   document.body.appendChild(content_overlay);


}

