function dl_define_resize_utilities() {
   var content_overlay = document.getElementById("dl_tabcontent_overlay");
   var content = document.getElementById("dl_tabcontent");
   var button = document.getElementById("dl_button_x");

   var m_pos;
   function resize(ev) {
      var to_add = m_pos - ev.y;
      m_pos = ev.y;

      var new_value = parseInt(getComputedStyle(content, '').height) + to_add;
      
      if (new_value + 2 < content_overlay.clientHeight){
         content.style.height = new_value + "px";
         if (new_value > 300)
            button.style.bottom = (new_value-30) + "px";
         else
            button.style.bottom = "270px";
      }
   }

   function stop_resize() {
      if (document.selection) {
         document.selection.empty()
      } else { 
         window.getSelection().removeAllRanges()
      }
      content_overlay.style.setProperty("display", "none", "important");
      document.removeEventListener("mousemove", resize, false);
   }

   content.addEventListener("mousedown", function (ev) {
      if (ev.target.id != "dl_tabcontent") {
         ev.preventDefault(ev);
         return;
      }
      content_overlay.style.setProperty("display", "block", "important");
      m_pos = ev.y;
      document.addEventListener("mousemove", resize, false);
   }, false);

   content.addEventListener("mouseup", function (ev) {
      ev.preventDefault(ev);
      stop_resize();
   }, false);

   content_overlay.addEventListener("mouseup", function (ev) {
      ev.preventDefault(ev);
      stop_resize();
   }, false);

   content_overlay.addEventListener("mouseleave", function (ev) {
      ev.preventDefault(ev);
      stop_resize();
   }, false);

};
